## vtk6 6.2.0+dfsg1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.8 FATAL_ERROR)

option(VTK_ENABLE_KITS "Build VTK using kits instead of modules." OFF)
mark_as_advanced(VTK_ENABLE_KITS)
if(VTK_ENABLE_KITS)
  # Kits use INTERFACE libraries which were introduced in 3.0.
  cmake_minimum_required(VERSION 3.0 FATAL_ERROR)
endif()

foreach(p
    CMP0020 # CMake 2.8.11
    CMP0022 # CMake 2.8.12
    CMP0025 # CMake 3.0
    CMP0053 # CMake 3.1
    )
  if(POLICY ${p})
    cmake_policy(SET ${p} NEW)
  endif()
endforeach()

# Set a consistent MACOSX_RPATH default across all CMake versions.
# When CMake 2.8.12 is required, change this default to 1.
# When CMake 3.0.0 is required, remove this block (see CMP0042).
if(NOT DEFINED CMAKE_MACOSX_RPATH)
  set(CMAKE_MACOSX_RPATH 0)
endif()

project(VTK)

# Objective-C++ compile flags.
# CMake has no equivalent of CMAKE_CXX_FLAGS for Objective-C++ (bug #4756)
# so we provide this in case the user needs to specify flags specifically
# for Objective-C++ source files.  For example, to build with garbage
# collection support, the -fobjc-gc flag would be used.
IF(APPLE)
  SET(VTK_OBJCXX_FLAGS_DEFAULT "")
  SET(VTK_REQUIRED_OBJCXX_FLAGS ${VTK_OBJCXX_FLAGS_DEFAULT} CACHE STRING "Extra flags for Objective-C++ compilation")
  MARK_AS_ADVANCED(VTK_REQUIRED_OBJCXX_FLAGS)
ENDIF()

set(VTK_CMAKE_DIR "${VTK_SOURCE_DIR}/CMake")
set(CMAKE_MODULE_PATH ${VTK_CMAKE_DIR} ${CMAKE_MODULE_PATH})

include(vtkModuleMacros)
include(vtkExternalData)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified.")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

# Test input data staging directory.
file(RELATIVE_PATH vtk_reldir "${CMAKE_SOURCE_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}")
set(VTK_TEST_DATA_DIR "${ExternalData_BINARY_ROOT}/${vtk_reldir}/Testing")

# Test input data directory.
set(VTK_TEST_INPUT_DIR "${VTK_SOURCE_DIR}/Testing/Data")

# Test output directory.
set(VTK_TEST_OUTPUT_DIR "${VTK_BINARY_DIR}/Testing/Temporary")

# Set up our directory structure for output libraries and binaries
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${VTK_BINARY_DIR}/bin")
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  if(UNIX)
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${VTK_BINARY_DIR}/lib")
  else()
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${VTK_BINARY_DIR}/bin")
  endif()
endif()
if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${VTK_BINARY_DIR}/lib")
endif()
mark_as_advanced(CMAKE_RUNTIME_OUTPUT_DIRECTORY
  CMAKE_LIBRARY_OUTPUT_DIRECTORY
  CMAKE_ARCHIVE_OUTPUT_DIRECTORY
  )

include(vtkVersion)
set(VTK_VERSION
    "${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}.${VTK_BUILD_VERSION}")

option(VTK_IOS_BUILD "Build vtk.framework for iOS" OFF)
if (VTK_IOS_BUILD)
  include(vtkiOS)
  return()
endif()

option(VTK_ANDROID_BUILD "Build VTK for Android" OFF)
if (VTK_ANDROID_BUILD)
  include(vtkAndroid)
  return()
endif()

# some specific defaults for Andriod to give folks
# a reasonable starting point
if (ANDROID OR APPLE_IOS)
  SET( CMAKE_REQUIRE_LARGE_FILE_SUPPORT 2
       CACHE STRING "Result from TRY_RUN" FORCE)
  SET( CMAKE_REQUIRE_LARGE_FILE_SUPPORT__TRYRUN_OUTPUT ""
       CACHE STRING "Output from TRY_RUN" FORCE)
  SET( VTK_TYPE_CHAR_IS_SIGNED 1
     CACHE STRING "Result from TRY_RUN" FORCE)
  SET( VTK_ANSI_STREAM_EOF_RESULT 0
     CACHE STRING "Result from TRY_RUN" FORCE)
  SET( KWSYS_CHAR_IS_SIGNED 1
     CACHE STRING "Result from TRY_RUN" FORCE)
  SET( KWSYS_LFS_WORKS 2
     CACHE STRING "Result from TRY_RUN" FORCE)
  SET( KWSYS_LFS_WORKS__TRYRUN_OUTPUT ""
     CACHE STRING "Output from TRY_RUN" FORCE)

  option(BUILD_SHARED_LIBS "should be off for embedded" OFF)
  set(VTK_RENDERING_BACKEND OpenGL2)
  set(Module_vtkRenderingCore ON)
  option(VTK_Group_Rendering "off for embedded" OFF)
  option(VTK_Group_StandAlone "off for embedded" OFF)
  option(VTK_Group_Imaging "off for embedded" OFF)
  option(VTK_Group_MPI "off for embedded" OFF)
  option(VTK_Group_Views "off for embedded" OFF)
  option(VTK_Group_Qt "off for embedded" OFF)
  option(VTK_Group_Tk "off for embedded" OFF)
  option(VTK_Group_Web "off for embedded" OFF)

  # need int version for CPP
  if (${OPENGL_ES_VERSION} MATCHES 2.0)
    set(OPENGL_ES_VERSION_INT 20)
  endif()
  if (${OPENGL_ES_VERSION} MATCHES 3.0)
    set(OPENGL_ES_VERSION_INT 30)
  endif()

  if (APPLE_IOS)
    unset(OPENGL_INCLUDE_DIR CACHE)
    if (${OPENGL_ES_VERSION} MATCHES 2.0)
      find_path(OPENGL_INCLUDE_DIR ES2/gl.h
                ${CMAKE_OSX_SYSROOT}/System/Library/Frameworks/OpenGLES.framework/Headers
                ${_OPENGL_INCLUDE_DIR})
    elseif (${OPENGL_ES_VERSION} MATCHES 3.0)
      find_path(OPENGL_INCLUDE_DIR ES3/gl.h
                ${CMAKE_OSX_SYSROOT}/System/Library/Frameworks/OpenGLES.framework/Headers
                ${_OPENGL_INCLUDE_DIR})
    endif()
    find_library(OPENGL_gl_LIBRARY
       NAMES OpenGLES
       PATHS
         ${CMAKE_OSX_SYSROOT}/System/Library/Frameworks
         ${_OPENGL_LIB_PATH}
       )
  elseif (ANDROID)
    unset(OPENGL_INCLUDE_DIR CACHE)
    unset(OPENGL_gl_LIBRARY CACHE)
    unset(OPENGL_egl_LIBRARY CACHE)

    if (${OPENGL_ES_VERSION} MATCHES 2.0)
      find_path(OPENGL_INCLUDE_DIR GLES2/gl2.h
         ${ANDROID_NDK}/platforms/android-${ANDROID_NATIVE_API_LEVEL}/arch-${ANDROID_ARCH_NAME}/usr/include
         ${_OPENGL_INCLUDE_PATH}
         NO_DEFAULT_PATH
         )
      find_library(OPENGL_gl_LIBRARY
         NAMES GLESv2
         PATHS
           ${ANDROID_NDK}/platforms/android-${ANDROID_NATIVE_API_LEVEL}/arch-${ANDROID_ARCH_NAME}/usr/lib
           ${_OPENGL_LIB_PATH}
         )
    elseif (${OPENGL_ES_VERSION} MATCHES 3.0)
      find_path(OPENGL_INCLUDE_DIR GLES3/gl3.h
         ${ANDROID_NDK}/platforms/android-${ANDROID_NATIVE_API_LEVEL}/arch-${ANDROID_ARCH_NAME}/usr/include
         ${_OPENGL_INCLUDE_PATH}
         )
      find_library(OPENGL_gl_LIBRARY
         NAMES GLESv3
         PATHS
           ${ANDROID_NDK}/platforms/android-${ANDROID_NATIVE_API_LEVEL}/arch-${ANDROID_ARCH_NAME}/usr/lib
           ${_OPENGL_LIB_PATH}
         )
    endif()
    find_library(OPENGL_egl_LIBRARY
       NAMES EGL
       PATHS
         ${ANDROID_NDK}/platforms/android-${ANDROID_NATIVE_API_LEVEL}/arch-${ANDROID_ARCH_NAME}/usr/lib
         ${_OPENGL_LIB_PATH}
       )
  endif()
else()
  # Choose static or shared libraries.
  option(BUILD_SHARED_LIBS "Build VTK with shared libraries." ON)
endif()

set(VTK_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

#-----------------------------------------------------------------------------
# VTK installation structure
if(NOT VTK_INSTALL_RUNTIME_DIR)
  set(VTK_INSTALL_RUNTIME_DIR bin)
endif()
if(NOT VTK_INSTALL_LIBRARY_DIR)
  set(VTK_INSTALL_LIBRARY_DIR lib)
endif()
if(NOT VTK_INSTALL_ARCHIVE_DIR)
  set(VTK_INSTALL_ARCHIVE_DIR lib)
endif()
if(NOT VTK_INSTALL_INCLUDE_DIR)
  set(VTK_INSTALL_INCLUDE_DIR include/vtk-${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION})
endif()
if(NOT VTK_INSTALL_DATA_DIR)
  set(VTK_INSTALL_DATA_DIR share/vtk-${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION})
endif()
if(NOT VTK_INSTALL_DOC_DIR)
  set(VTK_INSTALL_DOC_DIR share/doc/vtk-${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION})
endif()
if(NOT VTK_INSTALL_PACKAGE_DIR)
  set(VTK_INSTALL_PACKAGE_DIR "lib/cmake/vtk-${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}")
endif()
if(NOT VTK_INSTALL_DOXYGEN_DIR)
  set(VTK_INSTALL_DOXYGEN_DIR ${VTK_INSTALL_DOC_DIR}/doxygen)
endif()
if(NOT VTK_INSTALL_TCL_DIR)
  # tclsh searches <prefix>/lib/tcltk and its subdirectories for pkgIndex.tcl files
  set(VTK_INSTALL_TCL_DIR lib/tcltk/vtk-${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION})
endif()
if(NOT VTK_INSTALL_EXPORT_NAME)
  set(VTK_INSTALL_EXPORT_NAME VTKTargets)
endif()
if(NOT VTK_MODULES_DIR)
  set(VTK_MODULES_DIR "${VTK_BINARY_DIR}/${VTK_INSTALL_PACKAGE_DIR}/Modules")
endif()
if(NOT VTK_WWW_DIR)
  set(VTK_WWW_DIR "${VTK_BINARY_DIR}/www")
endif()
if(NOT VTK_INSTALL_PYTHON_MODULE_DIR)
  set (VTK_INSTALL_PYTHON_MODULE_DIR "-NOTFOUND" CACHE
       PATH "Directory where python modules will be installed")
  mark_as_advanced(VTK_INSTALL_PYTHON_MODULE_DIR)
endif()
if(NOT VTK_BUILD_PYTHON_MODULE_DIR)
  set (VTK_BUILD_PYTHON_MODULE_DIR "-NOTFOUND" CACHE
       PATH "Directory where python modules will be put inside the build tree")
  mark_as_advanced(VTK_BUILD_PYTHON_MODULE_DIR)
endif()
if (CMAKE_CROSSCOMPILING AND NOT COMPILE_TOOLS_IMPORTED)
  # if CMAKE_CROSSCOMPILING is true, we need to import build-tools targets.
  find_package(VTKCompileTools REQUIRED)
  set (COMPILE_TOOLS_IMPORTED TRUE)
endif()

#-----------------------------------------------------------------------------
# Do we try to use system libraries by default?
option(VTK_USE_SYSTEM_LIBRARIES "Use the system's libraries by default." OFF)
mark_as_advanced(VTK_USE_SYSTEM_LIBRARIES)

#-----------------------------------------------------------------------------
# The third party macros are still used in one or two third party builds.
include(vtkThirdParty)

#-----------------------------------------------------------------------------
include(vtkCompilerExtras)
include(vtkBuildPath)

#-----------------------------------------------------------------------------
if(NOT EXISTS "${VTK_SOURCE_DIR}/.ExternalData/README.rst")
  # This file is always present in version-controlled source trees
  # so we must have been extracted from a source tarball with no
  # data objects needed for testing.  Turn off tests by default
  # since enabling them requires network access or manual data
  # store configuration.
  option(BUILD_TESTING "Build the testing tree." OFF)
endif()
include(CTest)

#-----------------------------------------------------------------------------
if(APPLE)
  mark_as_advanced(
    CMAKE_OSX_ARCHITECTURES
    CMAKE_OSX_DEPLOYMENT_TARGET
    CMAKE_OSX_SYSROOT
    )
endif()

#-----------------------------------------------------------------------------
# Does VTK require support for 64 bit file systems
INCLUDE(CheckCXXSourceRuns)
FILE(READ "${VTK_CMAKE_DIR}/vtkRequireLargeFilesSupport.cxx"
  VTK_REQUIRE_LARGE_FILE_SUPPORT_FILE)
CHECK_CXX_SOURCE_RUNS("${VTK_REQUIRE_LARGE_FILE_SUPPORT_FILE}"
  CMAKE_REQUIRE_LARGE_FILE_SUPPORT "Support for 64 bit file systems")
SET(VTK_REQUIRE_LARGE_FILE_SUPPORT ${CMAKE_REQUIRE_LARGE_FILE_SUPPORT})

#-----------------------------------------------------------------------------
# Does the const_reverse_iterator have the comparison operators? Before GCC
# 4.1 they were not present.
include(CheckCXXSourceCompiles)
set(VTK_CONST_REVERSE_ITERATOR_COMPARISON_FILE
"#include <vector>
int main()
{
  std::vector<int> test;
  std::vector<int>::const_reverse_iterator it = test.rbegin();
  it != test.rend();
  return 0;
}")
check_cxx_source_compiles("${VTK_CONST_REVERSE_ITERATOR_COMPARISON_FILE}"
  VTK_CONST_REVERSE_ITERATOR_COMPARISON)

#-----------------------------------------------------------------------------
# Provide compatibility options.
option(VTK_LEGACY_REMOVE "Remove all legacy code completely." OFF)
option(VTK_LEGACY_SILENT "Silence all legacy code messages." OFF)
mark_as_advanced(VTK_LEGACY_REMOVE VTK_LEGACY_SILENT)

#-----------------------------------------------------------------------------
# VTK requires special compiler flags on some platforms.
include(vtkDetermineCompilerFlags)

# Tell VTK source files they are being built inside VTK.
add_definitions(-DVTK_IN_VTK)

#-----------------------------------------------------------------------------
if(BUILD_TESTING)
  include(vtkLegacyData)
endif()

# Provide an option for tests requiring "large" input data
option(VTK_USE_LARGE_DATA "Enable tests requiring \"large\" data" OFF)

#-----------------------------------------------------------------------------

=== Accelerators/Piston/CMakeLists.txt ===
find_package(CUDA REQUIRED)
find_path(PISTON_INCLUDE
  PistonCodingStyle.xml
  "/Source/PISTON/github/PISTON"
  DOC "PISTON library's source directory")

set(Module_SRCS
  vtkDataSetToPiston.cxx
  vtkPistonAlgorithm.cxx
  vtkPistonDataObject.cxx
  vtkPistonContour.cxx
  vtkPistonMapper.cxx
  vtkPistonToDataSet.cxx
  vtkPistonScalarsColors.cxx
  vtkPistonSlice.cxx
  vtkPistonSort.cxx
  vtkPistonThreshold.cxx
  )

set( Module_CUDA_SRCS
  vtkPistonConverters.cu
  vtkPistonContour.cu
  vtkPistonMapper.cu
  vtkPistonSlice.cu
  vtkPistonSort.cu
  vtkPistonThreshold.cu
)

if(BUILD_SHARED_LIBS)
  set(GPGPU_BUILD_TYPE SHARED)
endif()
set(CUDA_ATTACH_VS_BUILD_RULE_TO_CUDA_FILE OFF) #otherwise C_SOURCES is empty in VS
vtk_module_impl() #chicken and egg, I need list of include dirs of the module for nvcc's use before vtk_module_library is called
include_directories(${${vtk-module}_DEPENDS_INCLUDE_DIRS} ${PISTON_INCLUDE} ${CUDA_INCLUDE_DIR})
cuda_compile(Module_CUDA_C_SRCS ${Module_CUDA_SRCS} ${GPGPU_BUILD_TYPE})

set_source_files_properties(
  ${Module_CUDA_C_SRCS}
  WRAP_EXCLUDE
  )

list(APPEND Module_SRCS ${Module_CUDA_C_SRCS})

vtk_module_library(vtkAcceleratorsPiston ${Module_SRCS})
vtk_module_link_libraries(vtkAcceleratorsPiston LINK_PRIVATE ${CUDA_LIBRARIES})
if(APPLE)
  vtk_module_link_libraries(vtkAcceleratorsPiston LINK_PRIVATE /usr/local/cuda/lib/libtlshook.dylib)
endif()

=== Charts/Core/CMakeLists.txt ===
set(Module_SRCS
  vtkAxis.cxx
  vtkAxisExtended.cxx
  vtkCategoryLegend.cxx
  vtkChart.cxx
  vtkChartBox.cxx
  vtkChartHistogram2D.cxx
  vtkChartLegend.cxx
  vtkChartMatrix.cxx
  vtkChartParallelCoordinates.cxx
  vtkChartPie.cxx
  vtkChartXY.cxx
  vtkChartXYZ.cxx
  vtkColorLegend.cxx
  vtkColorTransferControlPointsItem.cxx
  vtkColorTransferFunctionItem.cxx
  vtkCompositeControlPointsItem.cxx
  vtkCompositeTransferFunctionItem.cxx
  vtkContextPolygon.cxx
  vtkControlPointsItem.cxx
  vtkLookupTableItem.cxx
  vtkPiecewiseControlPointsItem.cxx
  vtkPiecewiseFunctionItem.cxx
  vtkPiecewisePointHandleItem.cxx
  vtkPlot.cxx
  vtkPlot3D.cxx
  vtkPlotBag.cxx
  vtkPlotBar.cxx
  vtkPlotBox.cxx
  vtkPlotFunctionalBag.cxx
  vtkPlotGrid.cxx
  vtkPlotHistogram2D.cxx
  vtkPlotLine.cxx
  vtkPlotLine3D.cxx
  vtkPlotParallelCoordinates.cxx # This adds a vtkInfovisCore dep for one class...
  vtkPlotPie.cxx
  vtkPlotPoints.cxx
  vtkPlotPoints3D.cxx
  vtkPlotStacked.cxx
  vtkPlotSurface.cxx
  vtkScalarsToColorsItem.cxx
  vtkScatterPlotMatrix.cxx
  )

set_source_files_properties(
  vtkChart
  vtkControlPointsItem
  vtkPlot
  vtkPlot3D
  vtkScalarsToColorsItem
  ABSTRACT
  )

set_source_files_properties(
  vtkContextPolygon
  WRAP_EXCLUDE
)

set_source_files_properties(
  vtkContextPolygon
  PROPERTIES WRAP_SPECIAL 1
)

vtk_module_library(vtkChartsCore ${Module_SRCS})

=== Common/Core/CMakeLists.txt ===
# Core configuration options.
if("${CMAKE_SIZEOF_VOID_P}" GREATER 4)
 set(VTK_USE_64BIT_IDS_DEFAULT ON)
else()
 set(VTK_USE_64BIT_IDS_DEFAULT OFF)
endif()

option(VTK_USE_64BIT_IDS "Build VTK with 64 bit ids"
  ${VTK_USE_64BIT_IDS_DEFAULT})

option(VTK_DEBUG_LEAKS "Build leak checking support into VTK." OFF)

# This option determines the behavior of the New methods of vtkObject derived
# classes. If this option is off then only classes specifically using the
# vtkObjectFactoryNewMacro and vtkAbstractObjectFactoryNewMacro will allow for
# overrides. If the method is on then vtkStandardNewMacro will use the
# vtkObjectFactoryNewMacro's implementation body.
option(VTK_ALL_NEW_OBJECT_FACTORY
  "Build all vtkObject derived classes with object factory new methods." OFF)

mark_as_advanced(VTK_DEBUG_LEAKS VTK_USE_64BIT_IDS VTK_ALL_NEW_OBJECT_FACTORY)

set(vtkCommonCore_EXPORT_OPTIONS
  VTK_DEBUG_LEAKS
  VTK_USE_64BIT_IDS
  VTK_ALL_NEW_OBJECT_FACTORY
  )

# Choose which multi-threaded parallelism library to use
set(VTK_SMP_IMPLEMENTATION_TYPE "Sequential" CACHE STRING
  "Which multi-threaded parallelism implementation to use. Options are Sequential, Simple, Kaapi or TBB"
)
set_property(CACHE VTK_SMP_IMPLEMENTATION_TYPE PROPERTY STRINGS Sequential Simple Kaapi TBB)

if( NOT ("${VTK_SMP_IMPLEMENTATION_TYPE}" STREQUAL "Kaapi" OR
         "${VTK_SMP_IMPLEMENTATION_TYPE}" STREQUAL "TBB" OR
         "${VTK_SMP_IMPLEMENTATION_TYPE}" STREQUAL "Simple") )
  set(VTK_SMP_IMPLEMENTATION_TYPE "Sequential")
endif()

if ("${VTK_SMP_IMPLEMENTATION_TYPE}" STREQUAL "TBB")
  find_package(TBB REQUIRED)
  set(VTK_SMP_IMPLEMENTATION_LIBRARIES "")
  if (TBB_LIBRARY)
    list(APPEND VTK_SMP_IMPLEMENTATION_LIBRARIES optimized ${TBB_LIBRARY})
  endif()
  if (TBB_LIBRARY_DEBUG)
    list(APPEND VTK_SMP_IMPLEMENTATION_LIBRARIES debug ${TBB_LIBRARY_DEBUG})
  endif()
  set(VTK_SMP_ATOMIC_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/SMP/TBB")
  include_directories(${TBB_INCLUDE_DIRS})
  # This needs to be here because all modules that include vtkAtomic.h
  # need to include tbb/atomic.h
  list(APPEND vtkCommonCore_SYSTEM_INCLUDE_DIRS ${TBB_INCLUDE_DIRS})
elseif ("${VTK_SMP_IMPLEMENTATION_TYPE}" STREQUAL "Kaapi")
  find_package(XKaapi REQUIRED)
  include_directories(${XKAAPI_INCLUDE_DIRS})
  set(VTK_SMP_IMPLEMENTATION_LIBRARIES ${XKAAPI_LIBRARIES})
  set(VTK_SMP_ATOMIC_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/SMP/Sequential")
  list(APPEND vtkCommonCore_SYSTEM_INCLUDE_DIRS ${XKAAPI_INCLUDE_DIRS})
elseif ("${VTK_SMP_IMPLEMENTATION_TYPE}" STREQUAL "Simple")
  set(VTK_SMP_IMPLEMENTATION_LIBRARIES)
  set(VTK_SMP_ATOMIC_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/SMP/Sequential")
  message(WARNING "The Simple backend for SMP operations is an experimental backend that is mainly used for debugging currently. We recommend that you use either the TBB or the Kaapi backend for production work. Use the Sequential backend if you would like to turn off any SMP parallelism.")
elseif ("${VTK_SMP_IMPLEMENTATION_TYPE}" STREQUAL "Sequential")
  set(VTK_SMP_IMPLEMENTATION_LIBRARIES)
  set(VTK_SMP_ATOMIC_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/SMP/Sequential")
endif()

if(EXISTS ${VTK_SMP_ATOMIC_DIRECTORY}/vtkAtomicInt.cxx)
  set(VTK_ATOMIC_CXX_FILE ${VTK_SMP_ATOMIC_DIRECTORY}/vtkAtomicInt.cxx)
else()
  set(VTK_ATOMIC_CXX_FILE "")
endif()

configure_file(${VTK_SMP_ATOMIC_DIRECTORY}/vtkAtomicInt.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/vtkAtomicInt.h COPYONLY)

configure_file(SMP/${VTK_SMP_IMPLEMENTATION_TYPE}/vtkSMPThreadLocal.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/vtkSMPThreadLocal.h COPYONLY)

configure_file(SMP/${VTK_SMP_IMPLEMENTATION_TYPE}/vtkSMPToolsInternal.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/vtkSMPToolsInternal.h COPYONLY)

#-----------------------------------------------------------------------------

include_directories(${VTK_SOURCE_DIR}/ThirdParty/utf8/source)

SET(Module_SRCS
  vtkAbstractArray.cxx
  vtkAnimationCue.cxx
  vtkArrayCoordinates.cxx
  vtkArray.cxx
  vtkArrayExtents.cxx
  vtkArrayExtentsList.cxx
  vtkArrayIterator.cxx
  vtkArrayRange.cxx
  vtkArraySort.cxx
  vtkArrayWeights.cxx
  vtkBitArray.cxx
  vtkBitArrayIterator.cxx
  vtkBoxMuellerRandomSequence.cxx
  vtkBreakPoint.cxx
  vtkByteSwap.cxx
  vtkCallbackCommand.cxx
  vtkCharArray.cxx
  vtkCollection.cxx
  vtkCollectionIterator.cxx
  vtkCommand.cxx
  vtkCommonInformationKeyManager.cxx
  vtkConditionVariable.cxx
  vtkCriticalSection.cxx
  vtkDataArrayCollection.cxx
  vtkDataArrayCollectionIterator.cxx
  vtkDataArray.cxx
  vtkDataArraySelection.cxx
  vtkDebugLeaks.cxx
  vtkDebugLeaksManager.cxx
  vtkDoubleArray.cxx
  vtkDynamicLoader.cxx
  vtkEventForwarderCommand.cxx
  vtkFileOutputWindow.cxx
  vtkFloatArray.cxx
  vtkFloatingPointExceptions.cxx
  vtkGarbageCollector.cxx
  vtkGarbageCollectorManager.cxx
  vtkGaussianRandomSequence.cxx
  vtkIdListCollection.cxx
  vtkIdList.cxx
  vtkIdTypeArray.cxx
  vtkIndent.cxx
  vtkInformation.cxx
  vtkInformationDataObjectKey.cxx
  vtkInformationDoubleKey.cxx
  vtkInformationDoubleVectorKey.cxx
  vtkInformationIdTypeKey.cxx
  vtkInformationInformationKey.cxx
  vtkInformationInformationVectorKey.cxx
  vtkInformationIntegerKey.cxx
  vtkInformationIntegerPointerKey.cxx
  vtkInformationIntegerVectorKey.cxx
  vtkInformationIterator.cxx
  vtkInformationKey.cxx
  vtkInformationKeyVectorKey.cxx
  vtkInformationObjectBaseKey.cxx
  vtkInformationObjectBaseVectorKey.cxx
  vtkInformationRequestKey.cxx
  vtkInformationStringKey.cxx
  vtkInformationStringVectorKey.cxx
  vtkInformationUnsignedLongKey.cxx
  vtkInformationVariantKey.cxx
  vtkInformationVariantVectorKey.cxx
  vtkInformationVector.cxx
  vtkInstantiator.cxx
  vtkIntArray.cxx
  vtkIOStream.cxx
  vtkLargeInteger.cxx
  vtkLongArray.cxx
  vtkLookupTable.cxx
  vtkMappedDataArray.txx
  vtkMath.cxx
  vtkMinimalStandardRandomSequence.cxx
  vtkMultiThreader.cxx
  vtkMutexLock.cxx
  vtkObjectBase.cxx
  vtkObject.cxx
  vtkObjectFactoryCollection.cxx
  vtkObjectFactory.cxx
  vtkOldStyleCallbackCommand.cxx
  vtkOStreamWrapper.cxx
  vtkOStrStreamWrapper.cxx
  vtkOutputWindow.cxx
  vtkOverrideInformationCollection.cxx
  vtkOverrideInformation.cxx
  vtkPoints2D.cxx
  vtkPoints.cxx
  vtkPriorityQueue.cxx
  vtkRandomSequence.cxx
  vtkReferenceCount.cxx
  vtkScalarsToColors.cxx
  vtkShortArray.cxx
  vtkSignedCharArray.cxx
  vtkSimpleCriticalSection.cxx
  vtkSmartPointerBase.cxx
  vtkSortDataArray.cxx
  vtkStdString.cxx
  vtkStringArray.cxx
  vtkTimePointUtility.cxx
  vtkTimeStamp.cxx
  vtkTypedDataArray.txx
  vtkUnicodeStringArray.cxx
  vtkUnicodeString.cxx
  vtkUnsignedCharArray.cxx
  vtkUnsignedIntArray.cxx
  vtkUnsignedLongArray.cxx
  vtkUnsignedShortArray.cxx
  vtkVariantArray.cxx
  vtkVariant.cxx
  vtkVersion.cxx
  vtkVoidArray.cxx
  vtkWeakPointerBase.cxx
  vtkWindow.cxx
  vtkXMLFileOutputWindow.cxx
  vtkDataArrayTemplate.txx
  vtkDataArrayTemplateHelper.cxx
  vtkDenseArray.txx
  vtkSparseArray.txx
  vtkTypedArray.txx
  vtkTypeTemplate.h
  vtkType.h
  vtkSystemIncludes.h
  ${VTK_ATOMIC_CXX_FILE}
  vtkSMPThreadLocalObject.h
  vtkSMPTools.h
  SMP/${VTK_SMP_IMPLEMENTATION_TYPE}/vtkSMPTools.cxx
  ${CMAKE_CURRENT_BINARY_DIR}/vtkSMPToolsInternal.h
  ${CMAKE_CURRENT_BINARY_DIR}/vtkSMPThreadLocal.h
  ${CMAKE_CURRENT_BINARY_DIR}/vtkAtomicInt.h
  ${CMAKE_CURRENT_BINARY_DIR}/vtkConfigure.h
  ${CMAKE_CURRENT_BINARY_DIR}/vtkMathConfigure.h
  ${CMAKE_CURRENT_BINARY_DIR}/vtkVersionMacros.h
  )

set(${vtk-module}_HDRS
  vtkABI.h
  vtkArrayInterpolate.h
  vtkArrayInterpolate.txx
  vtkArrayIteratorIncludes.h
  vtkArrayIteratorTemplate.h
  vtkArrayIteratorTemplate.txx
  vtkArrayIteratorTemplateImplicit.txx
  vtkArrayPrint.h
  vtkArrayPrint.txx
  vtkAutoInit.h
  vtkDataArrayIteratorMacro.h
  vtkDataArrayTemplateImplicit.txx
  vtkIOStreamFwd.h
  vtkInformationInternals.h
  vtkMappedDataArray.h
  vtkMathUtilities.h
  vtkNew.h
  vtkSetGet.h
  vtkSmartPointer.h
  vtkTemplateAliasMacro.h
  vtkTypeTraits.h
  vtkTypedDataArray.h
  vtkTypedDataArrayIterator.h
  vtkVariantCast.h
  vtkVariantCreate.h
  vtkVariantExtract.h
  vtkVariantInlineOperators.h
  vtkWeakPointer.h
  vtkWin32Header.h
  vtkWindows.h
  ${CMAKE_CURRENT_BINARY_DIR}/vtkToolkits.h
  )

if(vtkCommonDataModel_ENABLED)
  include_directories(${VTK_BINARY_DIR}/Common/DataModel)
  set_property(SOURCE vtkInformationDataObjectKey.cxx
    PROPERTY COMPILE_DEFINITIONS vtkCommonDataModel_ENABLED)
endif()

# __int64 seems to be platform specific, turning on if
if(HAVE_VTK_SIZEOF__INT64)
  list(APPEND Module_SRCS
    vtkUnsigned__Int64Array.cxx
    vtk__Int64Array.cxx
    )
endif()

if(WIN32)
  # TODO: VTK_USE_X was once tested here but is now in another module
  list(APPEND Module_SRCS
    vtkWin32OutputWindow.cxx
    vtkWin32OutputWindowProcessEncoded.c
    vtkWin32ProcessOutputWindow.cxx
    )
  set_property(SOURCE vtkWin32OutputWindowProcessEncoded.c PROPERTY WRAP_EXCLUDE 1)
endif()

if(ANDROID)
  list(APPEND Module_SRCS
    vtkAndroidOutputWindow.cxx
    )
endif()

# Generate data for folding Unicode strings
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/vtkUnicodeString.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/vtkUnicodeString.cmake @ONLY)

# Setup clean configuration of vtkConfigure.h and vtkToolkits.h.
macro(VTK_PREPARE_CMAKEDEFINE not invar outvar)
  if(${not} ${invar})
    set(${outvar} 1)
  else()
    set(${outvar})
  endif()
endmacro()

vtk_prepare_cmakedefine("" CMAKE_WORDS_BIGENDIAN VTK_WORDS_BIGENDIAN)
vtk_prepare_cmakedefine("" CMAKE_NO_ANSI_STRING_STREAM VTK_NO_ANSI_STRING_STREAM)
vtk_prepare_cmakedefine(NOT VTK_EXPLICIT_TEMPLATES
                  VTK_NO_EXPLICIT_TEMPLATE_INSTANTIATION)
vtk_prepare_cmakedefine(NOT VTK_COMPILER_HAS_FULL_SPECIALIZATION
                        VTK_NO_FULL_TEMPLATE_SPECIALIZATION)

# Provide version macros through vtkConfigure.h for compatibility.
if(VTK_LEGACY_REMOVE)
  set(VTK_CONFIG_LEGACY_VERSION "")
else()
  set(VTK_CONFIG_LEGACY_VERSION "#include \"vtkVersionMacros.h\" // removed by VTK_LEGACY_REMOVE")
endif()

# Check for atomic functions
include(CheckSymbolExists)
if (WIN32)
  check_symbol_exists(InterlockedAdd "windows.h" VTK_HAS_INTERLOCKEDADD)
endif()


configure_file(vtkVersionMacros.h.in vtkVersionMacros.h @ONLY)
configure_file(vtkConfigure.h.in vtkConfigure.h @ONLY)
configure_file(vtkToolkits.h.in vtkToolkits.h @ONLY)

add_custom_command(
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/CaseFolding.txt
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/vtkUnicodeString.cmake
  COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/vtkUnicodeString.cmake
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/vtkUnicodeCaseFoldData.h
  )

set_source_files_properties(
  vtkUnicodeString.cxx
  OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/vtkUnicodeCaseFoldData.h
  )

if(VTK_TYPE_USE_LONG_LONG)
  list(APPEND Module_SRCS
    vtkLongLongArray.cxx
    vtkUnsignedLongLongArray.cxx
    )
endif()

if(VTK_TYPE_USE___INT64)
  list(APPEND Module_SRCS vtk__Int64Array.cxx)
  if(VTK_TYPE_CONVERT_UI64_TO_DOUBLE)
    list(APPEND Module_SRCS vtkUnsigned__Int64Array.cxx)
  endif()
endif()

# Configure data arrays for platform-independent fixed-size types.
# Match the type selection here to that in vtkType.h.
if(VTK_TYPE_CHAR_IS_SIGNED)
  set(VTK_TYPE_NATIVE_Int8 Char)
else()
  set(VTK_TYPE_NATIVE_Int8 SignedChar)
endif()
set(VTK_TYPE_NATIVE_Int16 Short)
set(VTK_TYPE_NATIVE_Int32 Int)
set(VTK_TYPE_NATIVE_UInt8 UnsignedChar)
set(VTK_TYPE_NATIVE_UInt16 UnsignedShort)
set(VTK_TYPE_NATIVE_UInt32 UnsignedInt)

if(VTK_SIZEOF_LONG_LONG MATCHES "^8$")
  set(VTK_TYPE_NATIVE_Int64 LongLong)
  set(VTK_TYPE_NATIVE_UInt64 UnsignedLongLong)
else()
  if(VTK_SIZEOF_LONG MATCHES "^8$")
    set(VTK_TYPE_NATIVE_Int64 Long)
    set(VTK_TYPE_NATIVE_UInt64 UnsignedLong)
  else()
    if(VTK_SIZEOF___INT64 MATCHES "^8$")
      set(VTK_TYPE_NATIVE_Int64 __Int64)
      if(VTK_TYPE_CONVERT_UI64_TO_DOUBLE)
        set(VTK_TYPE_NATIVE_UInt64 Unsigned__Int64)
      endif()
    endif()
  endif()
endif()
set(VTK_TYPE_NATIVE_Float32 Float)
set(VTK_TYPE_NATIVE_Float64 Double)

=== Common/DataModel/CMakeLists.txt ===
set(Module_SRCS
  vtkAbstractCellLocator.cxx
  vtkAbstractPointLocator.cxx
  vtkAdjacentVertexIterator.cxx
  vtkAMRBox.cxx
  vtkAMRUtilities.cxx
  vtkAnimationScene.cxx
  vtkAnnotation.cxx
  vtkAnnotationLayers.cxx
  vtkArrayData.cxx
  vtkAttributesErrorMetric.cxx
  vtkBiQuadraticQuad.cxx
  vtkBiQuadraticQuadraticHexahedron.cxx
  vtkBiQuadraticQuadraticWedge.cxx
  vtkBiQuadraticTriangle.cxx
  vtkBox.cxx
  vtkBSPCuts.cxx
  vtkBSPIntersections.cxx
  vtkCell3D.cxx
  vtkCellArray.cxx
  vtkCell.cxx
  vtkCellData.cxx
  vtkCellIterator.cxx
  vtkCellLinks.cxx
  vtkCellLocator.cxx
  vtkCellTypes.cxx
  vtkCompositeDataSet.cxx
  vtkCompositeDataIterator.cxx
  vtkCone.cxx
  vtkConvexPointSet.cxx
  vtkCubicLine.cxx
  vtkCylinder.cxx
  vtkDataSetCellIterator.cxx
  vtkDataObjectCollection.cxx
  vtkDataObject.cxx
  vtkDataObjectTypes.cxx
  vtkDataObjectTree.cxx
  vtkDataObjectTreeIterator.cxx
  vtkDataSetAttributes.cxx
  vtkDataSetCollection.cxx
  vtkDataSet.cxx
  vtkDirectedAcyclicGraph.cxx
  vtkDirectedGraph.cxx
  vtkDistributedGraphHelper.cxx
  vtkEdgeListIterator.cxx
  vtkEdgeTable.cxx
  vtkEmptyCell.cxx
  vtkExplicitCell.cxx
  vtkExtractStructuredGridHelper.cxx
  vtkFieldData.cxx
  vtkGenericAdaptorCell.cxx
  vtkGenericAttributeCollection.cxx
  vtkGenericAttribute.cxx
  vtkGenericCell.cxx
  vtkGenericCellIterator.cxx
  vtkGenericCellTessellator.cxx
  vtkGenericDataSet.cxx
  vtkGenericEdgeTable.cxx
  vtkGenericInterpolatedVelocityField.cxx
  vtkGenericPointIterator.cxx
  vtkGenericSubdivisionErrorMetric.cxx
  vtkGeometricErrorMetric.cxx
  vtkGraph.cxx
  vtkGraphEdge.cxx
  vtkGraphInternals.cxx
  vtkHexagonalPrism.cxx
  vtkHexahedron.cxx
  vtkHierarchicalBoxDataIterator.cxx
  vtkHierarchicalBoxDataSet.cxx
  vtkHyperOctreeCursor.cxx
  vtkHyperOctree.cxx
  vtkHyperOctreePointsGrabber.cxx
  vtkHyperTree.cxx
  vtkHyperTreeCursor.cxx
  vtkHyperTreeGrid.cxx
  vtkImageData.cxx
  vtkImageIterator.cxx
  vtkImplicitBoolean.cxx
  vtkImplicitDataSet.cxx
  vtkImplicitFunctionCollection.cxx
  vtkImplicitFunction.cxx
  vtkImplicitHalo.cxx
  vtkImplicitSelectionLoop.cxx
  vtkImplicitSum.cxx
  vtkImplicitVolume.cxx
  vtkImplicitWindowFunction.cxx
  vtkIncrementalOctreeNode.cxx
  vtkIncrementalOctreePointLocator.cxx
  vtkIncrementalPointLocator.cxx
  vtkInEdgeIterator.cxx
  vtkInformationQuadratureSchemeDefinitionVectorKey.cxx
  vtkIterativeClosestPointTransform.cxx
  vtkKdNode.cxx
  vtkKdTree.cxx
  vtkKdTreePointLocator.cxx
  vtkLine.cxx
  vtkLocator.cxx
  vtkMappedUnstructuredGrid.txx
  vtkMappedUnstructuredGridCellIterator.txx
  vtkMarchingSquaresLineCases.cxx
  vtkMarchingCubesTriangleCases.cxx
  vtkMeanValueCoordinatesInterpolator.cxx
  vtkMergePoints.cxx
  vtkMultiBlockDataSet.cxx
  vtkMultiPieceDataSet.cxx
  vtkMutableDirectedGraph.cxx
  vtkMutableUndirectedGraph.cxx
  vtkNonLinearCell.cxx
  vtkNonMergingPointLocator.cxx
  vtkOctreePointLocator.cxx
  vtkOctreePointLocatorNode.cxx
  vtkOrderedTriangulator.cxx
  vtkOutEdgeIterator.cxx
  vtkPath.cxx
  vtkPentagonalPrism.cxx
  vtkPerlinNoise.cxx
  vtkPiecewiseFunction.cxx
  vtkPixel.cxx
  vtkPixelExtent.cxx
  vtkPlaneCollection.cxx
  vtkPlane.cxx
  vtkPlanes.cxx
  vtkPlanesIntersection.cxx
  vtkPointData.cxx
  vtkPointLocator.cxx
  vtkPointSet.cxx
  vtkPointSetCellIterator.cxx
  vtkPointsProjectedHull.cxx
  vtkPolyDataCollection.cxx
  vtkPolyData.cxx
  vtkPolygon.cxx
  vtkPolyhedron.cxx
  vtkPolyLine.cxx
  vtkPolyPlane.cxx
  vtkPolyVertex.cxx
  vtkPyramid.cxx
  vtkQuad.cxx
  vtkQuadraticEdge.cxx
  vtkQuadraticHexahedron.cxx
  vtkQuadraticLinearQuad.cxx
  vtkQuadraticLinearWedge.cxx
  vtkQuadraticPolygon.cxx
  vtkQuadraticPyramid.cxx
  vtkQuadraticQuad.cxx
  vtkQuadraticTetra.cxx
  vtkQuadraticTriangle.cxx
  vtkQuadraticWedge.cxx
  vtkQuadratureSchemeDefinition.cxx
  vtkQuadric.cxx
  vtkRectilinearGrid.cxx
  vtkReebGraph.cxx
  vtkReebGraphSimplificationMetric.cxx
  vtkSelection.cxx
  vtkSelectionNode.cxx
  vtkSimpleCellTessellator.cxx
  vtkSmoothErrorMetric.cxx
  vtkSphere.cxx
  vtkSpline.cxx
  vtkStructuredData.cxx
  vtkStructuredExtent.cxx
  vtkStructuredGrid.cxx
  vtkStructuredPointsCollection.cxx
  vtkStructuredPoints.cxx
  vtkStructuredVisibilityConstraint.cxx
  vtkSuperquadric.cxx
  vtkTable.cxx
  vtkTensor.cxx
  vtkTetra.cxx
  vtkTreeBFSIterator.cxx
  vtkTree.cxx
  vtkTreeDFSIterator.cxx
  vtkTriangle.cxx
  vtkTriangleStrip.cxx
  vtkTriQuadraticHexahedron.cxx
  vtkUndirectedGraph.cxx
  vtkUniformGrid.cxx
  vtkUnstructuredGrid.cxx
  vtkUnstructuredGridBase.cxx
  vtkUnstructuredGridCellIterator.cxx
  vtkVertex.cxx
  vtkVertexListIterator.cxx
  vtkVoxel.cxx
  vtkWedge.cxx
  vtkXMLDataElement.cxx
  vtkTreeIterator.cxx
  vtkBoundingBox.cxx
  vtkAtom.cxx
  vtkBond.cxx
  vtkMolecule.cxx
  vtkAbstractElectronicData.cxx
  vtkCellType.h

  # Header only classes
  vtkDataArrayDispatcher.h
  vtkDispatcher.h
  vtkDispatcher_Private.h
  vtkDoubleDispatcher.h
  vtkVector.h
  vtkVectorOperators.h
  vtkColor.h
  vtkRect.h

  # New classes for AMR
  vtkNonOverlappingAMR.cxx
  vtkOverlappingAMR.cxx
  vtkAMRInformation.cxx
  vtkAMRDataInternals.cxx
  vtkUniformGridAMR.cxx
  vtkUniformGridAMRDataIterator.cxx
  )

set(${vtk-module}_HDRS
  vtkCellType.h
  vtkMappedUnstructuredGrid.h
  vtkMappedUnstructuredGridCellIterator.h
  )

set_source_files_properties(
  vtkAbstractCellLocator
  vtkAbstractPointLocator
  vtkCell
  vtkCell3D
  vtkCellIterator
  vtkCompositeDataIterator
  vtkCompositeDataSet
  vtkDataObjectTree
  vtkAbstractElectronicData
  vtkDataSet
  vtkDataSetGhostGenerator
  vtkDistributedGraphHelper
  vtkExplicitCell
  vtkGenericAttribute
  vtkGenericAdaptorCell
  vtkGenericCellIterator
  vtkGenericCellTessellator
  vtkGenericDataSet
  vtkGenericPointIterator
  vtkGenericSubdivisionErrorMetric
  vtkGraph
  vtkHyperOctreeCursor
  vtkHyperOctreePointsGrabber
  vtkHyperTree
  vtkHyperTreeCursor
  vtkImplicitFunction
  vtkIncrementalPointLocator
  vtkInformationQuadratureSchemeDefinitionVectorKey
  vtkLocator
  vtkNonLinearCell
  vtkPointSet
  vtkSpline
  vtkStructuredData
  vtkTreeIterator
  vtkUnstructuredGridBase
  ABSTRACT
  )

set_source_files_properties(
  vtkAMRBox
  vtkAtom
  vtkBond
  vtkBoundingBox
  vtkCellType
  vtkDataArrayDispatcher
  vtkDispatcher_Private
  vtkDispatcher
  vtkDoubleDispatcher
  vtkMappedUnstructuredGrid.txx
  vtkMappedUnstructuredGridCellIterator.txx
  vtkMarchingSquaresLineCases
  vtkMarchingCubesTriangleCases
  vtkImageIterator
  vtkImageProgressIterator
  vtkPixelExtent.cxx
  vtkVector
  vtkColor
  vtkRect
  vtkVectorOperators
  vtkAMRDataInternals
  WRAP_EXCLUDE
  )

set_source_files_properties(
  vtkCellType.h
  vtkColor.h
  vtkRect.h
  vtkVector.h
  PROPERTIES WRAP_SPECIAL 1
  )

vtk_module_library(vtkCommonDataModel ${Module_SRCS})

=== Filters/Core/CMakeLists.txt ===
set(Module_SRCS
  vtkAppendFilter.cxx
  vtkAppendPolyData.cxx
  vtkAppendSelection.cxx
  vtkArrayCalculator.cxx
  vtkAssignAttribute.cxx
  vtkAttributeDataToFieldDataFilter.cxx
  vtkCellDataToPointData.cxx
  vtkCleanPolyData.cxx
  vtkClipPolyData.cxx
  vtkCompositeDataProbeFilter.cxx
  vtkConnectivityFilter.cxx
  vtkContourFilter.cxx
  vtkContourGrid.cxx
  vtkContourHelper.cxx
  vtkDataObjectGenerator.cxx
  vtkDataObjectToDataSetFilter.cxx
  vtkDataSetEdgeSubdivisionCriterion.cxx
  vtkDataSetToDataObjectFilter.cxx
  vtkDecimatePolylineFilter.cxx
  vtkDecimatePro.cxx
  vtkDelaunay2D.cxx
  vtkDelaunay3D.cxx
  vtkElevationFilter.cxx
  vtkExecutionTimer.cxx
  vtkFeatureEdges.cxx
  vtkFieldDataToAttributeDataFilter.cxx
  vtkGlyph2D.cxx
  vtkGlyph3D.cxx
  vtkHedgeHog.cxx
  vtkHull.cxx
  vtkIdFilter.cxx
  vtkMarchingCubes.cxx
  vtkMarchingSquares.cxx
  vtkMaskFields.cxx
  vtkMaskPoints.cxx
  vtkMaskPolyData.cxx
  vtkMassProperties.cxx
  vtkMergeDataObjectFilter.cxx
  vtkMergeFields.cxx
  vtkMergeFilter.cxx
  vtkPointDataToCellData.cxx
  vtkPolyDataConnectivityFilter.cxx
  vtkPolyDataNormals.cxx
  vtkProbeFilter.cxx
  vtkQuadricClustering.cxx
  vtkQuadricDecimation.cxx
  vtkRearrangeFields.cxx
  vtkReverseSense.cxx
  vtkSimpleElevationFilter.cxx
  vtkSmoothPolyDataFilter.cxx
  vtkStripper.cxx
  vtkStructuredGridOutlineFilter.cxx
  vtkSynchronizedTemplates2D.cxx
  vtkSynchronizedTemplates3D.cxx
  vtkSynchronizedTemplatesCutter3D.cxx
  vtkTensorGlyph.cxx
  vtkThreshold.cxx
  vtkThresholdPoints.cxx
  vtkTransposeTable.cxx
  vtkTriangleFilter.cxx
  vtkTubeFilter.cxx
  vtkVectorDot.cxx
  vtkVectorNorm.cxx
  vtkWindowedSincPolyDataFilter.cxx

  vtkCutter.cxx
  vtkCompositeCutter.cxx
  vtkGridSynchronizedTemplates3D.cxx
  vtkRectilinearSynchronizedTemplates.cxx
  vtkEdgeSubdivisionCriterion.cxx
  vtkStreamingTessellator.cxx
  vtkImplicitPolyDataDistance.cxx
  vtkStreamerBase.cxx
  vtkCenterOfMass.cxx

  vtkGhostArray.cxx
  vtkImageAppend.cxx
  vtkStructuredGridAppend.cxx
  vtkAppendCompositeDataLeaves.cxx
  )

set_source_files_properties(
  vtkEdgeSubdivisionCriterion
  vtkStreamerBase
  ABSTRACT
  )

set_source_files_properties(
  vtkContourHelper
  WRAP_EXCLUDE
  )

vtk_module_library(vtkFiltersCore ${Module_SRCS})

=== Filters/Parallel/CMakeLists.txt ===
set(Module_SRCS
  vtkCollectGraph.cxx
  vtkCollectPolyData.cxx
  vtkCollectTable.cxx
  vtkCutMaterial.cxx
  vtkDuplicatePolyData.cxx
  vtkExtractCTHPart.cxx
  vtkExtractPolyDataPiece.cxx
  vtkExtractUnstructuredGridPiece.cxx
  vtkExtractUserDefinedPiece.cxx
  vtkPCellDataToPointData.cxx
  vtkPExtractArraysOverTime.cxx
  vtkPKdTree.cxx
  vtkPLinearExtrusionFilter.cxx
  vtkPMaskPoints.cxx
  vtkPOutlineCornerFilter.cxx
  vtkPOutlineFilter.cxx
  vtkPOutlineFilterInternals.cxx
  vtkPPolyDataNormals.cxx
  vtkPProbeFilter.cxx
  vtkPProjectSphereFilter.cxx
  vtkPReflectionFilter.cxx
  vtkPResampleFilter.cxx
  vtkPSphereSource.cxx
  vtkPYoungsMaterialInterface.cxx
  vtkPassThroughFilter.cxx
  vtkPieceRequestFilter.cxx
  vtkPieceScalars.cxx
  vtkPipelineSize.cxx
  vtkProcessIdScalars.cxx
  vtkRectilinearGridOutlineFilter.cxx
  vtkTransmitPolyDataPiece.cxx
  vtkTransmitStructuredDataPiece.cxx
  vtkTransmitRectilinearGridPiece.cxx
  vtkTransmitStructuredGridPiece.cxx
  vtkTransmitUnstructuredGridPiece.cxx
  )
set_source_files_properties(
  vtkBlockDistribution.h
  HEADER_FILE_ONLY
  )

set_source_files_properties(
  ${vtk-module}ObjectFactory.cxx
  vtkPOutlineFilterInternals.cxx
  WRAP_EXCLUDE
  )

vtk_module_library(vtkFiltersParallel ${Module_SRCS})

=== Filters/SMP/CMakeLists.txt ===
set(Module_SRCS
  vtkSMPContourGrid.cxx
  vtkSMPContourGridManyPieces.cxx
  vtkSMPMergePoints.cxx
  vtkSMPMergePolyDataHelper.cxx
  vtkThreadedSynchronizedTemplates3D.cxx
  vtkSMPTransform.cxx
  vtkSMPWarpVector.cxx
  )

set_source_files_properties(
  vtkSMPMergePolyDataHelper
  WRAP_EXCLUDE
  )

vtk_module_library(vtkFiltersSMP ${Module_SRCS})

=== Filters/StatisticsGnuR/CMakeLists.txt ===
set(Module_SRCS
  vtkRRandomTableSource.cxx
  vtkRCalculatorFilter.cxx
  vtkRInterface.cxx
  vtkRAdapter.cxx
  vtkContingencyStatisticsGnuR.cxx
  vtkCorrelativeStatisticsGnuR.cxx
  vtkDescriptiveStatisticsGnuR.cxx
  vtkPCAStatisticsGnuR.cxx

  ${CMAKE_CURRENT_BINARY_DIR}/${vtk-module}ObjectFactory.cxx
)

find_package(R)
include_directories(${R_INCLUDE_DIR})

# Configure the module specific settings into a module configured header.
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/vtkFiltersStatisticsGnuRConfigure.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/vtkFiltersStatisticsGnuRConfigure.h)
set(${vtk-module}_HDRS
  ${CMAKE_CURRENT_BINARY_DIR}/vtkFiltersStatisticsGnuRConfigure.h
  )

# Set up some of the module specific preprocessor definitions.
set(${vtk-module}_EXPORT_CODE "#include \"vtkFiltersStatisticsGnuRConfigure.h\"")

set_source_files_properties(
  vtkRAdapter.cxx
  ${vtk-module}ObjectFactory
  WRAP_EXCLUDE
  )

# Now to generate our object factory.
set( vtk_module_overrides
  vtkContingencyStatistics
  vtkCorrelativeStatistics
  vtkDescriptiveStatistics
  vtkPCAStatistics
  )

# Now we iterate and create that class file...
foreach(_class ${vtk_module_overrides})
  set(vtk_module_${_class}_override ${_class}GnuR)
  set(_override ${vtk_module_${_class}_override})
  set(_vtk_override_includes "${_vtk_override_includes}
#include \"${_override}.h\"")
  set(_vtk_override_creates "${_vtk_override_creates}
VTK_CREATE_CREATE_FUNCTION(${_override})")
  set(_vtk_override_do "${_vtk_override_do}
  this->RegisterOverride(\"${_class}\",
                         \"${_override}\",
                         \"Override for ${vtk-module} module\", 1,
                         vtkObjectFactoryCreate${_override});")
endforeach()

# Now lets create the object factory classes
string(TOUPPER ${vtk-module} VTK-MODULE)
configure_file(${VTK_CMAKE_DIR}/vtkObjectFactory.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/${vtk-module}ObjectFactory.h)
configure_file(${VTK_CMAKE_DIR}/vtkObjectFactory.cxx.in
  ${CMAKE_CURRENT_BINARY_DIR}/${vtk-module}ObjectFactory.cxx)

vtk_module_library(vtkFiltersStatisticsGnuR ${Module_SRCS})

vtk_module_link_libraries(vtkFiltersStatisticsGnuR LINK_PRIVATE ${R_LIBRARIES})

=== GUISupport/Qt/CMakeLists.txt ===
include(vtkQt)

# set up sources to build
set(QVTKLibSrcs
  vtkEventQtSlotConnect.cxx
  vtkQtConnection.cxx
  QVTKApplication.cxx
  QVTKInteractor.cxx
  QVTKInteractorAdapter.cxx
  QVTKWidget.cxx
  QFilterTreeProxyModel.cxx
  QVTKPaintEngine.cxx
  QVTKPaintEngine.h
  vtkQtAbstractModelAdapter.cxx
  vtkQtAnnotationLayersModelAdapter.cxx
  vtkQtDebugLeaksModel.cxx
  vtkQtDebugLeaksView.cxx
  vtkQtTableModelAdapter.cxx
  vtkQtTreeModelAdapter.cxx
  )

set(QVTKMocHeaders
  QVTKApplication.h
  QVTKInteractorAdapter.h
  QVTKInteractorInternal.h
  QVTKWidget.h
  vtkQtConnection.h
  QFilterTreeProxyModel.h
  vtkQtAbstractModelAdapter.h
  vtkQtAnnotationLayersModelAdapter.h
  vtkQtDebugLeaksModel.h
  vtkQtDebugLeaksView.h
  vtkQtTableModelAdapter.h
  vtkQtTreeModelAdapter.h
  )

if(VTK_USE_X AND VTK_USE_TDX)
  set(QVTKMocHeaders ${QVTKMocHeaders}
    vtkTDxQtUnixDevices.h
    )
  set(QVTKLibSrcs ${QVTKLibSrcs}
    vtkTDxQtUnixDevices.cxx
    )
endif()

if(VTK_USE_X)
  find_package(X11 REQUIRED)
  include_directories(${X11_INCLUDE_DIR})
endif()

set(QVTKNonMocHeaders
  QVTKWin32Header.h
  vtkEventQtSlotConnect.h
  QVTKInteractor.h
  )

if(VTK_QT_VERSION VERSION_GREATER "4")
  find_package(Qt5Widgets REQUIRED QUIET)
  include_directories(${Qt5Widgets_INCLUDE_DIRS})
  add_definitions(${Qt5Widgets_DEFINITIONS})

  qt5_wrap_cpp(QVTKLibMocSrcs ${QVTKMocHeaders})

  set(QT_LIBRARIES ${Qt5Widgets_LIBRARIES})

  # When this module is loaded by an app, load Qt too.
  vtk_module_export_code_find_package(Qt5Widgets)
else()
  # import Qt4 build settings
  set(QT_USE_QTNETWORK 1)
  find_package(Qt4 REQUIRED QUIET)
  mark_as_advanced(QT_QMAKE_EXECUTABLE)
  include(${QT_USE_FILE})

  qt4_wrap_cpp(QVTKLibMocSrcs ${QVTKMocHeaders})
endif()

foreach(opt
    QT_RCC_EXECUTABLE
    QT_MOC_EXECUTABLE
    QT_UIC_EXECUTABLE
    QT_QMAKE_EXECUTABLE
    )
  set(VTK_${opt} "${${opt}}")
  list(APPEND vtkGUISupportQt_EXPORT_OPTIONS VTK_${opt})
endforeach()

set(${vtk-module}_NO_HeaderTest 1)
vtk_module_library(${vtk-module}
  ${QVTKLibSrcs} ${QVTKLibMocSrcs}
  ${QVTKNonMocHeaders} ${QVTKMocHeaders}
  )

vtk_module_link_libraries(${vtk-module} LINK_PUBLIC ${QT_LIBRARIES})

if(VTK_USE_X)
  vtk_module_link_libraries(${vtk-module} LINK_PRIVATE ${X11_LIBRARIES})
endif()

if(APPLE)
  if(VTK_USE_CARBON)
    vtk_module_link_libraries(${vtk-module} LINK_PRIVATE "-framework Carbon" )
  endif()
endif()

# This build plugin logic should just get migrated into a module I think.
if(BUILD_SHARED_LIBS)
  set(PluginLibSrcs Q4VTKWidgetPlugin.cxx)

  set(PluginMocHeaders Q4VTKWidgetPlugin.h)

  if(VTK_QT_VERSION VERSION_GREATER "4")
    find_package(Qt5Designer REQUIRED QUIET)
    add_definitions(${Qt5Designer_DEFINITIONS})
    include_directories(${Qt5Designer_INCLUDE_DIRS})
    qt5_wrap_cpp(PluginMocSrcs ${PluginMocHeaders})
    set(QT_LIBRARIES ${Qt5Designer_LIBRARIES})
  else()
    add_definitions(-DQT_PLUGIN)
    include_directories(${QT_QTDESIGNER_INCLUDE_DIR})
    qt4_wrap_cpp(PluginMocSrcs ${PluginMocHeaders})
    set(QT_LIBRARIES ${QT_QTGUI_LIBRARY} ${QT_QTCORE_LIBRARY})
  endif()

  # add QVTK plugin from sources
  # stand-alone as it doesn't depend on QVTK library
  add_library(QVTKWidgetPlugin
    SHARED
    ${PluginLibSrcs}
    ${PluginMocSrcs}
    )

  set_target_properties(QVTKWidgetPlugin PROPERTIES COMPILE_DEFINITIONS QT_NO_DEBUG)

  # link with Qt libs
  vtk_module_link_libraries(QVTKWidgetPlugin ${QT_LIBRARIES})

  # install rules

  # The VTK_INSTALL_QT_PLUGIN_DIR variable sets the location
  # in which the Qt plugin will be installed.  It may or may not contain
  # variable references to CMAKE_INSTALL_PREFIX and VTK_INSTALL_QT_DIR.
  # The default is to install to VTK_INSTALL_QT_DIR under the installation
  # prefix.  The default VTK_INSTALL_QT_DIR will allow the designer plugin
  # path to be set to vtk-install-prefix/plugins to get the plugin.
  if(NOT VTK_INSTALL_QT_DIR)
    set(VTK_INSTALL_QT_DIR plugins/designer)
  endif()

  # If no runtime is to be installed then do not install the qt plugin.
  if(VTK_INSTALL_NO_RUNTIME)
    set(VTK_INSTALL_NO_QT_PLUGIN 1)
  endif()

  if(NOT VTK_INSTALL_NO_QT_PLUGIN)
    # Set default plugin install directory.
    set(DOLLAR "$")
    if(DEFINED VTK_INSTALL_QT_PLUGIN_DIR)
    else()
      set(VTK_INSTALL_QT_PLUGIN_DIR
        "${DOLLAR}{CMAKE_INSTALL_PREFIX}/${DOLLAR}{VTK_INSTALL_QT_DIR}"
        CACHE STRING "Directory in which the VTK Qt plugin is placed during installation.")
      mark_as_advanced(VTK_INSTALL_QT_PLUGIN_DIR)
    endif()

    # Configure the plugin install script.  This is used instead of
    # INSTALL TARGETS to allow the plugin to be installed outside the
    # main install prefix.  Attach the script as a post-install script.
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/PluginInstall.cmake.in
      ${CMAKE_CURRENT_BINARY_DIR}/PluginInstall.cmake
      @ONLY)
    set_target_properties(${vtk-module} PROPERTIES POST_INSTALL_SCRIPT
      ${CMAKE_CURRENT_BINARY_DIR}/PluginInstall.cmake)
  endif()
endif()

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/CTestCustom.ctest.in"
  "${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.ctest" @ONLY)

=== GUISupport/QtOpenGL/CMakeLists.txt ===
include(vtkQt)

set(MocHeaders ${QVTKMocHeaders}
  QVTKGraphicsItem.h
  QVTKWidget2.h
  )
set(LibSrcs ${QVTKLibSrcs}
  QVTKGraphicsItem.cxx
  QVTKWidget2.cxx
  )

if(VTK_QT_VERSION VERSION_GREATER "4")
  find_package(Qt5OpenGL REQUIRED QUIET)
  include_directories(${Qt5OpenGL_INCLUDE_DIRS})
  add_definitions(${Qt5OpenGL_DEFINITIONS})
  qt5_wrap_cpp(LibMocSrcs ${MocHeaders})

  set(QT_LIBRARIES ${Qt5OpenGL_LIBRARIES})

  # When this module is loaded by an app, load Qt too.
  vtk_module_export_code_find_package(Qt5OpenGL)
else()
  # import Qt4 build settings
  set(QT_USE_QTOPENGL 1)
  find_package(Qt4 REQUIRED QUIET)
  include(${QT_USE_FILE})

  qt4_wrap_cpp(LibMocSrcs ${MocHeaders})
endif()

set(${vtk-module}_NO_HeaderTest 1)
vtk_module_library(${vtk-module} ${LibSrcs} ${LibMocSrcs})
vtk_module_link_libraries(${vtk-module} LINK_PRIVATE ${QT_LIBRARIES})

=== GUISupport/QtSQL/CMakeLists.txt ===
include(vtkQt)

# set up sources to build
set(LibSrcs
  vtkQtSQLDatabase.cxx
  vtkQtSQLQuery.cxx
  vtkQtTimePointUtility.cxx
  )

include_directories(${CMAKE_CURRENT_BINARY_DIR})

if(VTK_QT_VERSION VERSION_GREATER "4")
  find_package(Qt5Widgets REQUIRED QUIET)
  find_package(Qt5Sql REQUIRED QUIET)

  set(_qt_include_dirs ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Sql_INCLUDE_DIRS})
  list(REMOVE_DUPLICATES _qt_include_dirs)
  include_directories(${_qt_include_dirs})

  set(_qt_definitions ${Qt5Widgets_DEFINITIONS} ${Qt5Sql_DEFINITIONS})
  list(REMOVE_DUPLICATES _qt_definitions)
  add_definitions(${_qt_definitions})

  set(QT_LIBRARIES ${Qt5Widgets_LIBRARIES} ${Qt5Sql_LIBRARIES})

  # When this module is loaded by an app, load Qt too.
  vtk_module_export_code_find_package(Qt5Widgets)
  vtk_module_export_code_find_package(Qt5Sql)
else()
  # import Qt4 build settings
  set(QT_USE_QTSQL 1)
  find_package(Qt4 REQUIRED QUIET)
  include(${QT_USE_FILE})
endif()

set(${vtk-module}_NO_HeaderTest 1)
vtk_module_library(${vtk-module} ${LibSrcs})

# Apply user-defined properties to the library target.
if(VTK_LIBRARY_PROPERTIES)
  set_target_properties(${vtk-module} PROPERTIES ${VTK_LIBRARY_PROPERTIES})
endif()

vtk_module_link_libraries(${vtk-module} LINK_PRIVATE ${QT_LIBRARIES})

=== debian/changelog ===
vtk6 (6.2.0+dfsg1-10build1) xenial; urgency=medium

  * Rebuild against libmysqlclient20.

 -- Robie Basak <robie.basak@ubuntu.com>  Tue, 05 Apr 2016 13:04:46 +0000

vtk6 (6.2.0+dfsg1-10) unstable; urgency=medium

  * [81e7008] d/p/101: Correct install path for Java files within build system
  * [61b464c] d/control: Set minimum version for libgl2ps-dev, Closes: #766491
  * [4ac3ffc] d/control: Enable module vtkRenderingExternal, Closes: #810344
  * [7ae06a0] d/p/102: Enable use of system proj4, Closes: #750184
  * [ce3f3ad] d/control: Enable system LIBPROJ4
  * [7720d44] Apply new patches 101 also 102 in source code
  * [d446bd8] d/control: Update standards version to 3.9.7
  * [70da96e] d/control: depends python-vtk6 and tcl-vtk6 on libvtk6.2-qt 
  * [2e881c5] Update watchfile to only search for 6.X.X versions
  * [e28b82b] d/control, d/rules: Move to qt5 also on armel, armhf
  * [f2883f3] d/p/104: Enables compiling with gcc-6. Closes: #812296

 -- Gert Wollny <gw.fossdev@gmail.com>  Mon, 28 Mar 2016 08:55:49 +0000

vtk6 (6.2.0+dfsg1-9) unstable; urgency=medium

  * [842987d] Add the libvtk*Qt*.so files to libvtk6-qt-dev
  * [b9dee31] Update Java installation locations Closes: #773420 
  * [c15ed1e] Move Python packages out of *-dev packages and provide
      a symlink in the python-vtk6 package instead Closes: #737325
      Closes: #773379 
  * [74543a2] add overrides and move PythonTK lib to python package
  * [2685ea2] Make perl scripts executable

 -- Gert Wollny <gw.fossdev@gmail.com>  Wed, 17 Feb 2016 12:13:56 +0000

vtk6 (6.2.0+dfsg1-8) unstable; urgency=medium

  [ Anton Gladky ]
  * [3bf2478] Add allow-stderr to autopkgtest. (Closes: #767338)

  [ Matthias Klose ]
  * [78abebb] Set JVM max memory to 1024m.

 -- Anton Gladky <gladk@debian.org>  Fri, 12 Feb 2016 20:37:38 +0100

vtk6 (6.2.0+dfsg1-7) unstable; urgency=medium

  * Add patch 96_* to fix a race condition in vtkLookupTableMapData
  * Add patch 97_* to correct some formulae in documentation 
  * Add Gert Wollny to uploaders 

 -- Gert Wollny <gw.fossdev@gmail.com>  Mon, 01 Feb 2016 00:38:48 +0100

vtk6 (6.2.0+dfsg1-6) unstable; urgency=medium

  * [18cd92a] Add missing libaec-dev to build-depends.

 -- Anton Gladky <gladk@debian.org>  Mon, 25 Jan 2016 21:55:22 +0100

vtk6 (6.2.0+dfsg1-5) unstable; urgency=medium

  [ Anton Gladky ]
  * [5110a34] Remove libqtwebkit-dev from depends of libvtk6-qt-dev.
  * Update d/copyright. Thanks to Thorsten Alteholz for pointing this out.

  [ Gert Wollny ]
  * [8fd5f1f] Move vtk-doc perl-scripts to dev-package. (Closes: #751395)

  [ Andreas Tille ]
  * [9581b71] Re-introduce libvtk6-java. (Closes: #798963)
  * [9689d50] Remove files from Git repository that are not part of
              upstream source

  [ Bas Couwenberg ]
  * [429f902] Add patch for GDAL 2.0 support. (Closes: #802624)

  [ Andreas Cadhalpun ]
  * [8c4dcf0] Add support for FFmpeg 2.9. (Closes: #803869)

 -- Anton Gladky <gladk@debian.org>  Sun, 20 Dec 2015 18:02:41 +0100

vtk6 (6.2.0+dfsg1-4) unstable; urgency=medium

  * [83a91c2] Move some more header-files into libvtk6-qt-dev. (Closes: #796891)
  * [4c30afa] Remove useless _formulas.log. First step to reproducible builds.

 -- Anton Gladky <gladk@debian.org>  Tue, 25 Aug 2015 20:13:44 +0200

vtk6 (6.2.0+dfsg1-3) unstable; urgency=medium

  [ Anton Gladky ]
  * [f225c63] Use the current tk-version. (Closes: #750200)
  * [c44cb24] Add BD on libnetcdf-cxx-legacy-dev. (Closes: #794040)

  [ Nico Schlömer ]
  * [1ec0dac] Provide MPI capabilities. (Closes: #789168)

 -- Anton Gladky <gladk@debian.org>  Sat, 08 Aug 2015 09:24:52 +0200

vtk6 (6.2.0+dfsg1-2) unstable; urgency=medium

  * [73ff79a] Fix compilation on arm* with missing Qt. (Closes: #793304)

 -- Anton Gladky <gladk@debian.org>  Wed, 29 Jul 2015 16:10:50 -0700

vtk6 (6.2.0+dfsg1-1) unstable; urgency=medium

  * [458b38a] Put Qt-files into a separate package. (Closes: #750193)
  * [880e68d] Remove Qt4 dependencies. (Closes: #784557, #765491)
  * [8e7e02a] Apply cme fix dpkg-control.
  * [541359c] Clean conflicts with obsolete packages.
  * [1734f03] Rename patches.

 -- Anton Gladky <gladk@debian.org>  Tue, 19 May 2015 23:30:34 +0200

vtk6 (6.2.0+dfsg1-1~exp1) experimental; urgency=medium

  * [0a01541] Update install-files for 6.2 version.
  * [4bc3890] Update/remove patches.
  * [874a7d6] Update d/rules.
  * [60c9ecc] Update d/copyright
  * [eb727c1] Remove old patches.
  * [9b57b0d] Fix dep-3 header in patch.
  * [3612db2] Imported Upstream version 6.2.0+dfsg1
  * [8121882] Use wrap-and-sort.
  * [895a399] Use cme fix dpkg-control.
  * [ff73402] Better fix for #773424.
  * [d31a99c] Update descriptions in d/control.

 -- Anton Gladky <gladk@debian.org>  Thu, 26 Mar 2015 19:15:10 +0100

=== debian/control ===
Source: vtk6
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>,
           Gert Wollny <gw.fossdev@gmail.com> 
Section: graphics
Testsuite: autopkgtest
Priority: optional
Build-Depends: chrpath,
               cmake (>= 2.8.5),
               debhelper (>= 9),
               default-jdk,
               dh-python,
               doxygen-latex,
               dpkg-dev (>= 1.16.1~),
               ftgl-dev,
               ghostscript,
               gnuplot-nox,
               graphviz,
               hdf5-tools,
               javahelper,
               libalglib-dev,
               libavcodec-dev,
               libavformat-dev,
               libavutil-dev,
               libboost-all-dev,
               libdigest-md5-perl,
               libexpat-dev,
               libfreetype6-dev,
               libgdal-dev,
               libgl1-mesa-dev | libgl-dev,
               libgl2ps-dev (>= 1.3.8),
               libglew-dev,
               libglu1-mesa-dev | libglu-dev,
               libhdf5-mpi-dev,
               libjpeg-dev,
               libjsoncpp-dev,
               libmrmpi-dev,
               libmysqlclient-dev,
               libnetcdf-dev,
               libnetcdf-cxx-legacy-dev,
               libogg-dev,
               libosmesa6-dev,
               libpng-dev,
               libpq-dev,
               libproj-dev,
               libqt5opengl5-dev,
               libqt5webkit5-dev,
               libsqlite3-dev,
               libswscale-dev,
               libtheora-dev,
               libtiff-dev,
               libutfcpp-dev,
               libx11-dev,
               libxdmf-dev,
               libxml2-dev,
               libxpm-dev,
               libxt-dev,
               mpi-default-dev,
               pkg-config,
               python-all-dev (<< 2.8),
               python-all-dev (>= 2.7),
               python-autobahn,
               python-matplotlib,
               python-mpi4py,
               python-six,
               python-twisted,
               qtbase5-dev,
               qttools5-private-dev,
               r-base,
               r-base-core,
               r-base-dev,
               tcl-dev,
               texlive-binaries,
               texlive-math-extra,
               tk-dev,
               x11proto-core-dev,
               xauth,
               xvfb,
               zlib1g-dev
Standards-Version: 3.9.7
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/vtk6.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/vtk6.git
Homepage: http://www.vtk.org/
X-Python-Version: current

Package: libvtk6-dev
Architecture: any
Section: libdevel
Depends: libavcodec-dev,
         libavformat-dev,
         libavutil-dev,
         libc6-dev,
         libeigen3-dev,
         libexpat-dev,
         libfreetype6-dev,
         libgdal-dev,
         libgl1-mesa-dev | libgl-dev,
         libgl2ps-dev,
         libglu1-mesa-dev | libglu-dev,
         libjpeg-dev,
         libjsoncpp-dev,
         libmysqlclient-dev,
         libnetcdf-dev,
         libnetcdf-cxx-legacy-dev,
         libogg-dev,
         libpng-dev,
         libpq-dev,
         libpython-dev,
         libswscale-dev,
         libtheora-dev,
         libtiff-dev,
         libvtk6.2 (= ${binary:Version}),
         libvtk6-java (= ${binary:Version}),
         libx11-dev,
         libxdmf-dev,
         libxft-dev,
         libxml2-dev,
         libxss-dev,
         libxt-dev,
         mpi-default-dev,
         python-vtk6 (= ${binary:Version}),
         python-zope.interface,
         tcl-dev,
         tcl-vtk6 (= ${binary:Version}),
         tk-dev,
         vtk6 (= ${binary:Version}),
         x11proto-core-dev,
         zlib1g-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: vtk6-doc,
          vtk6-examples
Conflicts: libvtk5-dev
Replaces: libvtk5-dev
Description: VTK header files
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the VTK header files required to compile
 C++ programs that use VTK to do 3D visualisation.

Package: libvtk6-qt-dev
Architecture: any
Section: libdevel
Depends: libvtk6-dev (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         qtbase5-dev,
         qttools5-private-dev,
         libqt5opengl5-dev,
         libqt5webkit5-dev
Breaks: libvtk6-dev (<< 6.2.0+dfsg1-4)
Replaces: libvtk6-dev (<< 6.2.0+dfsg1-4)
Description: VTK header files, containing Qt files
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the VTK header files required to compile
 C++ programs that use VTK to do 3D visualisation. Qt files

Package: libvtk6.2
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: mpi-default-bin,
          vtk6-doc,
          vtk6-examples
Conflicts: libvtk6 (>> 6.0.0-7)
Replaces: libvtk5.8,
          libvtk6
Description: VTK libraries
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the shared libraries needed to run C++ programs
 that use VTK.

Package: libvtk6.2-qt
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: libvtk6.2 (<< 6.2.0+dfsg1-1)
Replaces: libvtk6.2 (<< 6.2.0+dfsg1-1)
Description: VTK libraries, Qt files
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the shared libraries needed to run C++ programs
 that use VTK. Qt files

Package: libvtk6-java
Architecture: any
Depends:
 ${java:Depends},
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 java-virtual-machine,
 libvtk6-dev (= ${binary:Version}),
 vtk6-doc,
 vtk6-examples
Section: java
Description: Visualization Toolkit - A high level 3D visualization library - java
 The Visualization Toolkit (VTK) is an object oriented, high level
 library that allows one to easily write C++ programs, Tcl, Python and
 Java scripts that do 3D visualization.
 .
 This package provides the VTK Java language support.

Package: python-vtk6
Architecture: any
Section: python
Depends: libvtk6.2 (= ${binary:Version}),
	 libvtk6.2-qt (= ${binary:Version}),
	 python-autobahn,
         python-mpi4py,
         python-six,
         python-twisted,
         python-zope.interface,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Suggests: mayavi2,
          vtk6-doc,
          vtk6-examples
Conflicts: python-vtk
Description: Python bindings for VTK
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the python bindings for VTK.

Package: tcl-vtk6
Architecture: any
Section: interpreters
Depends: libvtk6.2 (= ${binary:Version}),
	 libvtk6.2-qt (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: vtk6-doc,
          vtk6-examples
Description: Tcl bindings for VTK
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the shared libraries and executable that enable 
 one to use VTK from Tcl/Tk scripts.

Package: vtk6
Architecture: any
Section: interpreters
Depends: libvtk6.2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: vtk6-doc,
          vtk6-examples
Description: Binaries for VTK6
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides binaries for VTK6

Package: vtk6-doc
Architecture: all
Section: doc
Depends: doc-base,
         libjs-jquery,
         ${misc:Depends}
Suggests: libvtk6-dev,
          vtk6-examples
Description: VTK class reference documentation
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides documentation for VTK6

Package: vtk6-examples
Architecture: all
Section: graphics
Depends: ${misc:Depends}
Suggests: libvtk6-dev,
          python,
          python-vtk6,
          tcl-vtk6,
          tclsh,
          vtk6-doc
Description: VTK examples
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides examples for VTK6

=== debian/rules ===
#!/usr/bin/make -f
BUILDDIR = $(CURDIR)/debian/build

# export JAVA_HOME to help FindJava.cmake and FindJNI.cmake
export JAVA_HOME=/usr/lib/jvm/default-java

%:
	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR) --with python2 --with javahelper --parallel

extra_flags +=  \
  -DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_C_COMPILER=mpicc \
	-DCMAKE_CXX_COMPILER=mpic++ \
	-DBUILD_DOCUMENTATION=ON \
	-DBUILD_EXAMPLES=ON \
	-DBUILD_SHARED_LIBS=ON \
	-DBUILD_TESTING=OFF \
	-DVTK_USE_TK=ON \
	-DVTK_WRAP_JAVA=ON \
	-DVTK_WRAP_PYTHON=ON \
	-DVTK_WRAP_TCL=ON \
	-DVTK_USE_SYSTEM_EXPAT=ON \
	-DVTK_USE_SYSTEM_FREETYPE=ON \
	-DVTK_USE_SYSTEM_GL2PS=ON \
	-DVTK_USE_SYSTEM_HDF5=ON \
	-DVTK_USE_SYSTEM_JPEG=ON \
	-DVTK_USE_SYSTEM_LIBPROJ4=ON \
	-DVTK_USE_SYSTEM_LIBXML2=ON \
	-DVTK_USE_SYSTEM_OGGTHEORA=ON \
	-DVTK_USE_SYSTEM_PNG=ON \
	-DVTK_USE_SYSTEM_TIFF=ON \
	-DVTK_USE_SYSTEM_ZLIB=ON \
	-DVTK_USE_SYSTEM_JSONCPP=ON \
	-DVTK_USE_SYSTEM_NETCDF=ON \
	-DVTK_USE_SYSTEM_GLEW=ON \
	-DVTK_EXTRA_COMPILER_WARNINGS=ON \
	-DVTK_Group_Imaging=ON \
	-DVTK_Group_MPI=ON \
	-DVTK_Group_Tk=ON \
	-DVTK_Group_Views=ON \
	-DVTK_BUILD_ALL_MODULES=ON \
	-DMPI_CXX_INCLUDE_PATH="/usr/include/mpi" \
	-DVTK_INSTALL_LIBRARY_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)" \
	-DVTK_MAKE_INSTANTIATORS=ON \
	-DCMAKE_EXE_LINKER_FLAGS="-Wl,--as-needed" \
	-DCMAKE_MODULE_LINKER_FLAGS="-Wl,--as-needed" \
	-DCMAKE_SHARED_LINKER_FLAGS="-Wl,--as-needed" \
	-DCMAKE_BUILD_TYPE=None \
	-DVTK_USE_GCC_VISIBILITY=ON \
	-DModule_vtkRenderingExternal=ON

extra_flags += -DVTK_QT_VERSION=5	-DVTK_Group_Qt=ON

override_dh_auto_configure:
ifneq (,$(filter $(DEB_HOST_ARCH),$(noqt_archs)))
	echo '' > $(CURDIR)/Views/Qt/module.cmake
	echo '' > $(CURDIR)/GUISupport/QtWebkit/module.cmake
	echo '' > $(CURDIR)/Rendering/Qt/module.cmake
	echo '' > $(CURDIR)/GUISupport/QtOpenGL/module.cmake
	echo '' > $(CURDIR)/Examples/GUI/Qt/SimpleView/CMakeLists.txt
endif
	dh_auto_configure -- $(extra_flags)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR)

override_dh_auto_build:
	dh_auto_build
	# Make doc (see wiki/VTK/debian/buildingDoxygen)
	cd $(BUILDDIR) && make DoxygenDoc 
	# remove .md5 files
	find $(BUILDDIR)/Utilities/Doxygen/doc/html/ -name "*.md5" | xargs rm -f

override_dh_auto_install:
	dh_auto_install -X.pyc -X.pyo
	# Modify vtkWrapJava.cmake to properly upload JavaDependencies.cmake.in	from $VTK_DIR
	perl -pi -e "s|{dir}/JavaDependencies.cmake.in\"|{VTK_DIR}/JavaDependencies.cmake.in\"|" debian/tmp/usr/lib/cmake/vtk-6.2/vtkWrapJava.cmake
	# Correct headers for paraview
	perl -pi.bak -e "s|cxx|include|g" ThirdParty/netcdf/vtk_netcdfcpp.h
	mv $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/vtk.jar $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/vtk6.jar
	mv $(CURDIR)/debian/build/bin/vtkpython $(CURDIR)/debian/build/bin/vtk6python
	sed -i -e "s/FATAL_ERROR/STATUS/g" $(CURDIR)/debian/tmp/usr/lib/cmake/vtk-6.2/VTKTargets.cmake
	chrpath -d $(CURDIR)/debian/build/bin/vtk6python
	chrpath -d $(CURDIR)/debian/build/bin/pvtk
	chrpath -d $(CURDIR)/debian/build/bin/pvtkpython
	mv $(CURDIR)/debian/tmp/usr/bin/vtk $(CURDIR)/debian/tmp/usr/bin/vtk6
	find $(CURDIR)/debian/tmp/ -name "*.pyc" | xargs rm -f
	find $(CURDIR)/debian/tmp/ -name "*.pyo" | xargs rm -f
	sed -i -e "9 a\ append libPath /${DEB_HOST_MULTIARCH}" $(CURDIR)/debian/tmp/usr/lib/tcltk/vtk-6.2/pkgIndex.tcl

override_dh_install-arch:
	dh_install -a
	find $(CURDIR)/debian/libvtk6-dev/ -name "*Qt*" -exec rm {} \;
	find $(CURDIR)/debian/libvtk6.2/ -name "*Qt*" -exec rm {} \;
	find $(CURDIR)/debian/libvtk6-dev/ -name "libvtkRenderingPythonTkWidgets.so" -exec rm {} \;
	find $(CURDIR)/debian/libvtk6-dev/usr/include/ -name "Q*" -exec rm {} \;
	chmod 755 $(CURDIR)/debian/libvtk6-dev/usr/share/vtk-6.2/doxygen/*.pl
	rm -rf $(CURDIR)/debian/libvtk6-doc/usr/share/doc/vtk6-doc/html/_formulas.log
	mkdir -p  $(CURDIR)/debian/python-vtk6/usr/lib/$(DEB_HOST_MULTIARCH)/python2.7/site-packages/ && \
          cd $(CURDIR)/debian/python-vtk6/usr/lib/$(DEB_HOST_MULTIARCH)/python2.7/site-packages/ && \
	  ln -s  /usr/lib/python2.7/dist/packages/vtk vtk

=== debian/watch ===
version=3
opts=repacksuffix=+dfsg,uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/,dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$// \
https://github.com/Kitware/VTK/tags .*/v?(6\.\d\S*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
